org.eclipse.wst.jsdt.core.dom

## Interface IBinding

All Known Subinterfaces:
  IFunctionBinding, IPackageBinding, ITypeBinding, IVariableBinding

    public interface IBinding

A binding represents a named entity in the JavaScript language. The world of bindings provides an integrated picture of the structure of the program as seen from the compiler's point of view. This interface declare protocol common to the various different kinds of named entities in the JavaScript language: packages, types, fields, methods, constructors, and local variables.

This interface is not intended to be implemented by clients.

See Also:
  `IPackageBinding`, `ITypeBinding`, `IVariableBinding`, `Provisional API: This class/interface is part of an interim API that is still under development and expected to change significantly before reaching stability. It is being made available at this early stage to solicit feedback from pioneering adopters on the understanding that any code that uses this API will almost certainly be broken (repeatedly) as the API evolves.`

### Field Summary

Fields
`static int` `METHOD` Kind constant (value 4) indicating a method or constructor binding.
`static int` `PACKAGE` Kind constant (value 1) indicating a package binding.
`static int` `TYPE` Kind constant (value 2) indicating a type binding.
`static int` `VARIABLE` Kind constant (value 3) indicating a field or local variable binding.

### Method Summary

All Methods Instance Methods Abstract Methods
`boolean` `equals(java.lang.Object obj)` There is no special definition of equality for bindings; equality is simply object identity.
`IJavaScriptElement` `getJavaElement()` Returns the JavaScript element that corresponds to this binding.
`java.lang.String` `getKey()` Returns the key for this binding.
`int` `getKind()` Returns the kind of bindings this is.
`int` `getModifiers()` Returns the modifiers for this binding.
`java.lang.String` `getName()` Returns the name of this binding.
`boolean` `isDeprecated()` Return whether this binding is for something that is deprecated.
`boolean` `isEqualTo(IBinding binding)` Returns whether this binding has the same key as that of the given binding.
`boolean` `isRecovered()` Return whether this binding is created because the bindings recovery is enabled.
`java.lang.String` `toString()` Returns a string representation of this binding suitable for debugging purposes only.

### Field Detail

#### PACKAGE

    static final int PACKAGE

Kind constant (value 1) indicating a package binding. Bindings of this kind can be safely cast to `IPackageBinding`.

See Also:
  `getKind()`, `IPackageBinding`, Constant Field Values

#### TYPE

    static final int TYPE

Kind constant (value 2) indicating a type binding. Bindings of this kind can be safely cast to `ITypeBinding`.

See Also:
  `getKind()`, `ITypeBinding`, Constant Field Values

#### VARIABLE

    static final int VARIABLE

Kind constant (value 3) indicating a field or local variable binding. Bindings of this kind can be safely cast to `IVariableBinding`.

See Also:
  `getKind()`, `IVariableBinding`, Constant Field Values

#### METHOD

    static final int METHOD

Kind constant (value 4) indicating a method or constructor binding. Bindings of this kind can be safely cast to `IFunctionBinding`.

See Also:
  `getKind()`, `IFunctionBinding`, Constant Field Values

### Method Detail

#### getKind

    int getKind()

Returns the kind of bindings this is. That is one of the kind constants: `PACKAGE`, `TYPE`, `VARIABLE`, `METHOD`, or `MEMBER_VALUE_PAIR`.

Note that additional kinds might be added in the future, so clients should not assume this list is exhaustive and should program defensively, e.g. by having a reasonable default in a switch statement.

Returns:
  one of the kind constants

#### getName

    java.lang.String getName()

Returns the name of this binding. Details of the name are specified with each specific kind of binding.

Returns:
  the name of this binding

#### getModifiers

    int getModifiers()

Returns the modifiers for this binding.

Note that deprecated is not included among the modifiers. Use `isDeprecated` to find out whether a binding is deprecated.

Returns:
  the bit-wise or of `Modifier` constants
See Also:
  `Modifier`

#### isDeprecated

    boolean isDeprecated()

Return whether this binding is for something that is deprecated. A deprecated class, interface, field, method, or constructor is one that is marked with the 'deprecated' tag in its jsdoc comment.

Returns:
  `true` if this binding is deprecated, and `false` otherwise

#### isRecovered

    boolean isRecovered()

Return whether this binding is created because the bindings recovery is enabled. This binding is considered to be incomplete. Its internal state might be incomplete.

Returns:
  `true` if this binding is a recovered binding, and `false` otherwise

#### getJavaElement

    IJavaScriptElement getJavaElement()

Returns the JavaScript element that corresponds to this binding. Returns `null` if this binding has no corresponding JavaScript element.

For array types, this method returns the JavaScript element that corresponds to the array's element type. For raw and parameterized types, this method returns the JavaScript element of the erasure. For annotations, this methods returns the JavaScript element of the annotation type.

Here are the cases where a `null` should be expected:

- primitive types, including void
- null type
- capture types
- array types of any of the above
- the "length" field of an array type
- the default constructor of a source class
- the constructor of an anonymous class
- member value pairs

For all other kind of type, method, variable, annotation and package bindings, this method returns non-`null`.

Returns:
  the JavaScript element that corresponds to this binding, or `null` if none

#### getKey

    java.lang.String getKey()

Returns the key for this binding.

Within a connected cluster of bindings (for example, all bindings reachable from a given AST), each binding will have a distinct keys. The keys are generated in a manner that is predictable and as stable as possible. This last property makes these keys useful for comparing bindings between disconnected clusters of bindings (for example, the bindings between the "before" and "after" ASTs of the same javaScript unit).

The exact details of how the keys are generated is unspecified. However, it is a function of the following information:

- packages - the name of the package (for an unnamed package, some internal id)
- classes or interfaces - the VM name of the type and the key of its package
- array types - the key of the component type and number of dimensions
- primitive types - the name of the primitive type
- fields - the name of the field and the key of its declaring type
- methods - the name of the method, the key of its declaring type, and the keys of the parameter types
- constructors - the key of its declaring class, and the keys of the parameter types
- local variables - the name of the local variable, the index of the declaring block relative to its parent, the key of its method
- local types - the name of the type, the index of the declaring block relative to its parent, the key of its method
- anonymous types - the occurence count of the anonymous type relative to its declaring type, the key of its declaring type
- enum types - treated like classes
- annotation types - treated like interfaces
- type variables - the name of the type variable and the key of the generic type or generic method that declares that type variable
- generic type instances - the key of the generic type and the keys of the type arguments used to instantiate it, and whether the instance is explicit (a parameterized type reference) or implicit (a raw type reference)
- generic method instances - the key of the generic method and the keys of the type arguments used to instantiate it, and whether the instance is explicit (a parameterized method reference) or implicit (a raw method reference)
- members of generic type instances - the key of the generic type instance and the key of the corresponding member in the generic type

Note that the key for annotation bindings and member value pair bindings is not yet implemented. This returns `null` for these 2 kinds of bindings.
Recovered bindings have a unique key.

Returns:
  the key for this binding

#### equals

    boolean equals(java.lang.Object obj)

There is no special definition of equality for bindings; equality is simply object identity. Within the context of a single cluster of bindings, each binding is represented by a distinct object. However, between different clusters of bindings, the binding objects may or may not be different; in these cases, the client should compare bindings using `isEqualTo(IBinding)`, which checks their keys.

Overrides:
  `equals` in class `java.lang.Object`
Parameters:
  `obj` -
Returns:

#### isEqualTo

    boolean isEqualTo(IBinding binding)

Returns whether this binding has the same key as that of the given binding. Within the context of a single cluster of bindings, each binding is represented by a distinct object. However, between different clusters of bindings, the binding objects may or may not be different objects; in these cases, the binding keys are used where available.

Parameters:
  `binding` - the other binding, or `null`
Returns:
  `true` if the given binding is the identical object as this binding, or if the keys of both bindings are the same string; `false` if the given binding is `null`, or if the bindings do not have the same key, or if one or both of the bindings have no key
See Also:
  `getKey()`

#### toString

    java.lang.String toString()

Returns a string representation of this binding suitable for debugging purposes only.

Overrides:
  `toString` in class `java.lang.Object`
Returns:
  a debug string